# CzmlDataSource

#### new Cesium.CzmlDataSource(name)
DataSources/CzmlDataSource.js 4842

A `DataSource` which processes CZML.

Name | Type | Description
--- | --- | ---
`name` | String | optional An optional name for the data source. This value will be overwritten if a loaded document contains a name.

##### Demo:

- Cesium Sandcastle CZML Demo

### Members

#### static Cesium.CzmlDataSource.updaters : Array
DataSources/CzmlDataSource.js 4992

Gets the array of CZML processing functions.

#### changedEvent : Event
DataSources/CzmlDataSource.js 4917

Gets an event that will be raised when the underlying data changes.

#### clock : DataSourceClock
DataSources/CzmlDataSource.js 4887

Gets the clock settings defined by the loaded CZML. If no clock is explicitly defined in the CZML, the combined availability of all objects is returned. If only static data exists, this value is undefined.

#### clustering : EntityCluster
DataSources/CzmlDataSource.js 4962

Gets or sets the clustering options for this data source. This object can be shared between multiple data sources.

#### credit : Credit
DataSources/CzmlDataSource.js 4980

Gets the credit that will be displayed for the data source

#### entities : EntityCollection
DataSources/CzmlDataSource.js 4897

Gets the collection of `Entity` instances.

#### errorEvent : Event
DataSources/CzmlDataSource.js 4927

Gets an event that will be raised if an error is encountered during processing.

#### isLoading : Boolean
DataSources/CzmlDataSource.js 4907

Gets a value indicating if the data source is currently loading data.

#### loadingEvent : Event
DataSources/CzmlDataSource.js 4937

Gets an event that will be raised when the data source either starts or stops loading.

#### name : String
DataSources/CzmlDataSource.js 4875

Gets a human-readable name for this instance.

#### show : Boolean
DataSources/CzmlDataSource.js 4947

Gets whether or not this data source should be displayed.

### Methods

#### static Cesium.CzmlDataSource.load(czml, options) → Promise.<CzmlDataSource>
DataSources/CzmlDataSource.js 4865

Creates a Promise to a new instance loaded with the provided CZML data.

Name | Type | Description
--- | --- | ---
`czml` | Resource | String | Object | A url or CZML object to be processed.
`options` | CzmlDataSource.LoadOptions | optional An object specifying configuration options

##### Returns:

A promise that resolves to the new instance once the data is processed.

#### static Cesium.CzmlDataSource.processMaterialPacketData(object, propertyName, packetData, interval, sourceUri, entityCollection)
DataSources/CzmlDataSource.js 5096

A helper function used by custom CZML updater functions which creates or updates a `MaterialProperty` from a CZML packet.

Name | Type | Description
--- | --- | ---
`object` | Object | The object on which the property will be added or updated.
`propertyName` | String | The name of the property on the object.
`packetData` | Object | The CZML packet being processed.
`interval` | TimeInterval | A constraining interval for which the data is valid.
`sourceUri` | String | The originating uri of the data being processed.
`entityCollection` | EntityCollection | The collection being processsed.

#### static Cesium.CzmlDataSource.processPacketData(type, object, propertyName, packetData, interval, sourceUri, entityCollection)
DataSources/CzmlDataSource.js 5068

A helper function used by custom CZML updater functions which creates or updates a `Property` from a CZML packet.

Name | Type | Description
--- | --- | ---
`type` | function | The constructor function for the property being processed.
`object` | Object | The object on which the property will be added or updated.
`propertyName` | String | The name of the property on the object.
`packetData` | Object | The CZML packet being processed.
`interval` | TimeInterval | A constraining interval for which the data is valid.
`sourceUri` | String | The originating uri of the data being processed.
`entityCollection` | EntityCollection | The collection being processsed.

#### static Cesium.CzmlDataSource.processPositionPacketData(object, propertyName, packetData, interval, sourceUri, entityCollection)
DataSources/CzmlDataSource.js 5082

A helper function used by custom CZML updater functions which creates or updates a `PositionProperty` from a CZML packet.

Name | Type | Description
--- | --- | ---
`object` | Object | The object on which the property will be added or updated.
`propertyName` | String | The name of the property on the object.
`packetData` | Object | The CZML packet being processed.
`interval` | TimeInterval | A constraining interval for which the data is valid.
`sourceUri` | String | The originating uri of the data being processed.
`entityCollection` | EntityCollection | The collection being processsed.

#### load(czml, options) → Promise.<CzmlDataSource>
DataSources/CzmlDataSource.js 5038

Loads the provided url or CZML object, replacing any existing data.

Name | Type | Description
--- | --- | ---
`czml` | Resource | String | Object | A url or CZML object to be processed.
`options` | CzmlDataSource.LoadOptions | optional An object specifying configuration options

##### Returns:

A promise that resolves to this instances once the data is processed.

#### process(czml, options) → Promise.<CzmlDataSource>
DataSources/CzmlDataSource.js 5026

Processes the provided url or CZML object without clearing any existing data.

Name | Type | Description
--- | --- | ---
`czml` | Resource | String | Object | A url or CZML object to be processed.
`options` | Object | optional An object with the following properties:
Name | Type | Description
--- | --- | ---
`sourceUri` | String | optional Overrides the url to use for resolving relative links.

##### Returns:

A promise that resolves to this instances once the data is processed.

#### update(time) → Boolean
DataSources/CzmlDataSource.js 5051

Updates the data source to the provided time. This function is optional and is not required to be implemented. It is provided for data sources which retrieve data based on the current animation time or scene state. If implemented, update will be called by `DataSourceDisplay` once a frame.

Name | Type | Description
--- | --- | ---
`time` | JulianDate | The simulation time.

##### Returns:

True if this data source is ready to be displayed at the provided time, false otherwise.

### Type Definitions

#### Cesium.CzmlDataSource.LoadOptions
DataSources/CzmlDataSource.js 4824

Initialization options for the `load` method.

##### Properties:

Name | Type | Attributes | Description
--- | --- | --- | ---
`sourceUri` | Resource | string | <optional> | Overrides the url to use for resolving relative links.
`credit` | Credit | string | <optional> | A credit for the data source, which is displayed on the canvas.